// -------------------------------------------------------------------------------------
// 
// RPMain.CS                                                      Ulrich Mller 15.11.05
//                                                                 PCS1700  C# Final SP2
// Steuerung einer Raupe (Typ Power Bulldozer) 
// durch Button Down oder Pfeil-Tasten.
// Einsatz FishFace40.DLL, Klasse FishFace40
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFace40;

namespace RaupePur
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TrackBar trbSpeed;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Label lblVersion;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Panel pnlCommands;
		private System.Windows.Forms.Button cmdRight;
		private System.Windows.Forms.Button cmdLeft;
		private System.Windows.Forms.Button cmdForward;
		private System.Windows.Forms.Button cmdBack;
		private System.ComponentModel.Container components = null;

		private const int cMotLinks = 1, cMotRechts = 2;
		private const int cVor = 2, cRuck = 1, cAus = 0;

		private FishFace ft = new FishFace();
		private int Zeler = 0;

		public frmMain()
		{
			InitializeComponent();

		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.trbSpeed = new System.Windows.Forms.TrackBar();
			this.lblStatus = new System.Windows.Forms.Label();
			this.lblVersion = new System.Windows.Forms.Label();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cmdAction = new System.Windows.Forms.Button();
			this.pnlCommands = new System.Windows.Forms.Panel();
			this.cmdRight = new System.Windows.Forms.Button();
			this.cmdLeft = new System.Windows.Forms.Button();
			this.cmdForward = new System.Windows.Forms.Button();
			this.cmdBack = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.trbSpeed)).BeginInit();
			this.pnlCommands.SuspendLayout();
			this.SuspendLayout();
			// 
			// trbSpeed
			// 
			this.trbSpeed.LargeChange = 4;
			this.trbSpeed.Location = new System.Drawing.Point(32, 168);
			this.trbSpeed.Maximum = 7;
			this.trbSpeed.Name = "trbSpeed";
			this.trbSpeed.Size = new System.Drawing.Size(168, 42);
			this.trbSpeed.TabIndex = 4;
			this.trbSpeed.Value = 7;
			// 
			// lblStatus
			// 
			this.lblStatus.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.lblStatus.Location = new System.Drawing.Point(24, 232);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(176, 24);
			this.lblStatus.TabIndex = 5;
			this.lblStatus.Text = "ROBO RF Datalink : START";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblVersion
			// 
			this.lblVersion.Location = new System.Drawing.Point(24, 272);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(64, 56);
			this.lblVersion.TabIndex = 6;
			this.lblVersion.Text = "Version";
			// 
			// cmdEnde
			// 
			this.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdEnde.Location = new System.Drawing.Point(96, 272);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(104, 24);
			this.cmdEnde.TabIndex = 7;
			this.cmdEnde.Text = "Abbrechen";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(96, 304);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(104, 24);
			this.cmdAction.TabIndex = 8;
			this.cmdAction.Text = "START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// pnlCommands
			// 
			this.pnlCommands.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.cmdBack,
																					  this.cmdForward,
																					  this.cmdRight,
																					  this.cmdLeft});
			this.pnlCommands.Enabled = false;
			this.pnlCommands.Location = new System.Drawing.Point(24, 16);
			this.pnlCommands.Name = "pnlCommands";
			this.pnlCommands.Size = new System.Drawing.Size(176, 144);
			this.pnlCommands.TabIndex = 9;
			// 
			// cmdRight
			// 
			this.cmdRight.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdRight.Image")));
			this.cmdRight.Location = new System.Drawing.Point(116, 52);
			this.cmdRight.Name = "cmdRight";
			this.cmdRight.Size = new System.Drawing.Size(40, 40);
			this.cmdRight.TabIndex = 6;
			this.cmdRight.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdRight.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdRight_MouseDown);
			// 
			// cmdLeft
			// 
			this.cmdLeft.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdLeft.Image")));
			this.cmdLeft.Location = new System.Drawing.Point(20, 52);
			this.cmdLeft.Name = "cmdLeft";
			this.cmdLeft.Size = new System.Drawing.Size(40, 40);
			this.cmdLeft.TabIndex = 4;
			this.cmdLeft.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdLeft.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdLeft_MouseDown);
			// 
			// cmdForward
			// 
			this.cmdForward.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdForward.Image")));
			this.cmdForward.Location = new System.Drawing.Point(68, 8);
			this.cmdForward.Name = "cmdForward";
			this.cmdForward.Size = new System.Drawing.Size(40, 40);
			this.cmdForward.TabIndex = 11;
			this.cmdForward.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdForward.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdForward_MouseDown);
			// 
			// cmdBack
			// 
			this.cmdBack.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdBack.Image")));
			this.cmdBack.Location = new System.Drawing.Point(68, 96);
			this.cmdBack.Name = "cmdBack";
			this.cmdBack.Size = new System.Drawing.Size(40, 40);
			this.cmdBack.TabIndex = 12;
			this.cmdBack.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdBack.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdBack_MouseDown);
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdEnde;
			this.ClientSize = new System.Drawing.Size(224, 349);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.pnlCommands,
																		  this.cmdAction,
																		  this.cmdEnde,
																		  this.lblVersion,
																		  this.lblStatus,
																		  this.trbSpeed});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.KeyPreview = true;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "RaupePur";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.frmMain_KeyDown);
			this.KeyUp += new System.Windows.Forms.KeyEventHandler(this.frmMain_KeyUp);
			((System.ComponentModel.ISupportInitialize)(this.trbSpeed)).EndInit();
			this.pnlCommands.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void cmdAction_Click(object sender, System.EventArgs e) {
			try {
				ft.OpenInterface(IFTypen.ftROBO_first_USB, 0, true);
				lblVersion.Text     = "Version : " + ft.ActDevice.Firmware;
				cmdEnde.Text        = "HALT";
				cmdAction.Enabled   = false;
				pnlCommands.Enabled = true;
				lblStatus.Text      = "Ready to Run";
			}
			catch (FishFaceException eft) {
				lblStatus.Text = eft.Message;
			}
		}

		private void cmdEnde_Click(object sender, System.EventArgs e) {
			if(cmdEnde.Text == "HALT") {
				ft.CloseInterface();
				cmdEnde.Text        = "ENDE";
				cmdAction.Enabled   = true;
				pnlCommands.Enabled = false;
				lblStatus.Text      = "Interface angehalten";
			}
			else {
				this.Close();
			}
		}

		private void cmdLeft_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			TurnLeft();
		}

		private void cmdRight_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			TurnRight();
		}

		private void cmdForward_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			GoForward();
		}

		private void cmdBack_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			GoBack();
		}

		private void cmd_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e) {
			StopAll();
		}

		private void frmMain_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e) {
			if(cmdAction.Enabled) return;
			switch (e.KeyValue) {
				case 37:              // --- Left
					TurnLeft();
					break;
				case 38:              // --- Up
					GoForward();
					break;
				case 39:              // --- Right
					TurnRight();
					break;
				case 40:              // --- Down
					GoBack();
					break;
				default:
					break;
			}
			e.Handled = true;
		}

		private void frmMain_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e) {
			if(cmdAction.Enabled) return;
			switch (e.KeyValue) {
				case 37:              // --- Left
					StopAll();
					break;
				case 38:              // --- Up
					StopAll();
					break;
				case 39:              // --- Right
					StopAll();
					break;
				case 40:              // --- Down
					StopAll();
					break;
				default:
					break;
			}
			e.Handled = true;		
		}

		private void TurnLeft() {
			ft.SetMotor(cMotLinks, cVor, trbSpeed.Value);
			ft.SetMotor(cMotRechts, cRuck, trbSpeed.Value);
			lblStatus.Text = "Turn Left";
		}
		private void TurnRight() {
			ft.SetMotor(cMotLinks, cRuck, trbSpeed.Value);
			ft.SetMotor(cMotRechts, cVor, trbSpeed.Value);		
			lblStatus.Text = "Turn Right";
		}
		private void GoForward() {
			ft.SetMotor(cMotLinks, cVor, trbSpeed.Value);
			ft.SetMotor(cMotRechts, cVor, trbSpeed.Value);	
			lblStatus.Text = "Go Forward";
		}
		private void GoBack() {
			ft.SetMotor(cMotLinks, cRuck, trbSpeed.Value);
			ft.SetMotor(cMotRechts, cRuck, trbSpeed.Value);			
			lblStatus.Text = "Go Back";
		}
		private void StopAll() {
			ft.SetMotor(cMotLinks, cAus);
			ft.SetMotor(cMotRechts, cAus);		
			lblStatus.Text = "Steht";
		}
	}
}
